#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>

/** Mandatory include files **/

#include "pip_constant.h"
#include "pip_extern.h"

/** Application include files **/

#include "extern.h"


/******************************************************************************
  run_demo_2 ()

  Perform necessary event-checking for panel 2.
******************************************************************************/

run_demo_2 ()
{
  if (Win->update_event)
  {
    /** Timer update event **/
  }
  else
  {
    /** Widget event **/

    check_demo_2_widgets ();
  }
}



/******************************************************************************
  check_demo_2_widgets ()

  Check to see if specific widgets have been flagged by selection events.
******************************************************************************/

check_demo_2_widgets ()
{
  Widget *widget;

  /** Cloase panel 2 **/

  if (check_named_widget_flag (&widget, "close_button"))
  {
    close_panel (Console->event_panel);
  }

  /** Reset all widget flags (semi-mandatory) **/

  reset_all_flags ();
}



/******************************************************************************
  init_demo_2 ()

  Initialize widgets for panel 2.
******************************************************************************/

init_demo_2 ()
{
}



/******************************************************************************
  exit_demo_2 ()

  Clean-up widgets when exiting panel 2.
******************************************************************************/

exit_demo_2 ()
{
}
