#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>

#include "pip_constant.h"
#include "pip_extern.h"
#include "pip_generic.h"

#include "pip_c_xxxx.h"


/******************************************************************************
  xxxx_function (widget, line, function)

  Run the type-specific routine for widget <widget> that is associated with
  command <function>, using supplemental information from string <line>.
******************************************************************************/

xxxx_function (widget, line, function)
  Widget *widget;
  char *line;
  short function;
{
  switch (function)
  {
    case FUNCTION_HELP:
      xxxx_help (Console->formats[CONTROL_XXXX]);
      break;

    case FUNCTION_FORMAT:
      xxxx_format (Console->formats[CONTROL_XXXX]);
      break;

    case FUNCTION_LOAD:
      parse_format_defaults (Console->formats[CONTROL_XXXX], line);
      break;

    case FUNCTION_STORE:
      xxxx_store (widget, line);
      break;

    case FUNCTION_DUMP:
      xxxx_dump (widget);
      break;

    case FUNCTION_INITIALIZE:
      xxxx_initialize (widget);
      break;

    case FUNCTION_PARSE:
      xxxx_parse (widget, line);
      break;

    case FUNCTION_CLEAN:
      xxxx_clean (widget);
      break;

    case FUNCTION_SETUP:
      xxxx_setup (widget);
      break;

    case FUNCTION_EDIT:
      xxxx_edit (widget, line);
      break;

    case FUNCTION_SELECT:
      xxxx_select (widget);
      break;

    case FUNCTION_MOTION:
      break;
 
    case FUNCTION_RELEASE:
      break;

    case FUNCTION_EXECUTE:
      xxxx_execute (widget);
      break;

    case FUNCTION_DRAW:
      xxxx_draw (widget);
      break;

    default:
      throw_error ("Function unknown to xxxx", NULL);
      break;
  }
}



/******************************************************************************
  xxxx_help (format)

  Print a help message to stdout detailing the usage of any type-specific
  arguments for the widget <format>, including default values when possible.
******************************************************************************/

xxxx_help (format)
  Widget *format;
{
  printf ("\n");
  printf ("XXXX\n");
  printf ("    TEXT   <string>                text for state 1\n");
  printf ("\n");
}



/******************************************************************************
  xxxx_format (format)

  Set type-specific default for canonical widget <format>.
******************************************************************************/

xxxx_format (format)
  Widget *format;
{
  format->status[IS_SELECTABLE] =	TRUE;
  format->status[IS_ACTIVATABLE] =	TRUE;
  format->status[IS_EDITABLE] =		EDITABLE_PARTIAL;
  format->status[IS_MOTION_ACTIVE] =	FALSE;
  format->status[IS_BUFFERABLE] =	BUFFER_NORMAL;

  format->size.x =			DEFAULT_XXXX_DIMENSION_X;
  format->size.y =			DEFAULT_XXXX_DIMENSION_Y;
  format->spacing.x =			DEFAULT_XXXX_SPACING_X;
  format->spacing.y =			DEFAULT_XXXX_SPACING_Y;

  format->thickness[THICKNESS_SHADOW] =	3;
  format->thickness[THICKNESS_ACTIVE] =	2;

  format->gcs[GC_BODY] =		COLOR_CTRL_SURFACE;
  format->gcs[GC_BODY_INV] =		COLOR_CTRL_SURFACE_INV;
  format->gcs[GC_FONT_FIRST] =		COLOR_CTRL_TEXT_1;
  format->gcs[GC_FONT_SECOND] =		COLOR_CTRL_TEXT_1;

  format->fonts[FONT_FIRST] =		FONT_MEDIUM;
  format->fonts[FONT_SECOND] =		FONT_MEDIUM;

  format->format =			CONTROL_XXXX;
}



/******************************************************************************
  xxxx_store (widget, line)

  Copy type-specific initialization information for widget <widget> onto the
  end of string <line>, for later storage into a dump file.
******************************************************************************/

xxxx_store (widget, line)
  Widget *widget;
  char *line;
{
  int i;
  char subline[100];

  sprintf (subline, "INIT\t%d\n", widget->state);
  strcat (line, subline);
}



/******************************************************************************
  xxxx_dump (widget)

  Dump type-specific information for widget <widget> to stdout for the
  purposes of debugging.
******************************************************************************/

xxxx_dump (widget)
  Widget *widget;
{
  int i;

  generic_dump (widget);
}



/******************************************************************************
  xxxx_initialize (widget)

  Initialize widget <widget> with non-canonical information.
******************************************************************************/

xxxx_initialize (widget)
  Widget *widget;
{
  widget->format = CONTROL_XXXX;
  widget->subformat = CONTROL_NONE;
}



/******************************************************************************
  xxxx_parse (widget, line)

  Parse any type-specific commands in string <line> for widget <widget>,
  setting internal values as needed.
******************************************************************************/

xxxx_parse (widget, line)
  Widget *widget;
  char *line;
{
  int i, j,
      int_factor;

  char dos_line[100],
       tres_line[100],
       ch;

  double factor,
         atof();

  strcpy (dos_line, line);
  strip_first (dos_line);

  strcpy (tres_line, dos_line);
  strip_first (tres_line);

  factor = atof (tres_line);
  int_factor = atoi (tres_line);

  if (line[0] == 'A')
  {
    switch (dos_line[0])
    {
      /** OFFSET **/

      case 'O':

        widget->data[XXXX_D_WHATEVER] = int_factor;
        break;
    }

    line[0] = '#';
  }
}



/******************************************************************************
  xxxx_clean (widget)

  Clear up any parameter discrepancies in widget <widget>.
******************************************************************************/

xxxx_clean (widget)
  Widget *widget;
{
}



/******************************************************************************
  xxxx_setup (widget)

  Set up derived parameters (those not directly accessible to user) for
  widget <widget>.
******************************************************************************/

xxxx_setup (widget)
  Widget *widget;
{
  /** Set widget bounds **/

  widget->bound_offset.x = widget->thickness[THICKNESS_SHADOW] +
		widget->thickness[THICKNESS_ACTIVE];
  widget->bound_offset.y = widget->thickness[THICKNESS_SHADOW] +
		widget->thickness[THICKNESS_ACTIVE];
  widget->bound_size.x = 2*widget->bound_offset.x + widget->size.x;
  widget->bound_size.y = 2*widget->bound_offset.y + widget->size.y;
}



/******************************************************************************
  xxxx_edit (widget, line)

  Manage editing of widget <widget>, based on input string <line>.  The
  internal value <widget->reserve> determines editing status.
******************************************************************************/

xxxx_edit (widget, line)
  Widget *widget;
  char *line;
{
  switch (widget->reserve)
  {
    case EDIT_BEGIN:
      break;

    case EDIT_PROCESS:
      break;

    case EDIT_FINISH:
      break;
  }
}



/******************************************************************************
  xxxx_select (widget)

  Handle type-specific function of widget <widget> when it is first selected
  by the user.
******************************************************************************/

xxxx_select (widget)
  Widget *widget;
{
}



/******************************************************************************
  xxxx_execute (widget)

  Execute the function of widget <widget>, as when mouse xxxx is released
  or mouse motion occurs.
******************************************************************************/

xxxx_execute (widget)
  Widget *widget;
{
  widget->flag = TRUE;
}



/******************************************************************************
  xxxx_draw (widget)

  Draw the widget <widget>.
******************************************************************************/

xxxx_draw (widget)
  Widget *widget;
{
}
