#include <stdio.h>
#include <math.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>

#include "pip_constant.h"
#include "pip_extern.h"

struct xwindow_info *Win;

unsigned char Grey_Palette[5][8] =
			{{0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55},
 			 {0xAA, 0xFF, 0xAA, 0xFF, 0xAA, 0xFF, 0xAA, 0xFF},
 			 {0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00}};

unsigned char ColorControl[][3] = {
		{120, 120, 120},	/**  0 background  **/
		{ 90,  90,  90},	/**  1 shadow      **/
		{220, 220, 220},	/**  2 highlight   **/
		{170, 170, 170},	/**  3 surface     **/
		{150, 150, 150},	/**  4 surface inv **/
		{  0,   0,   0},	/**  5 dark        **/
		{100,  50,  50},	/**  6 dark inv    **/
		{  0,   0,   0},	/**  7 select      **/
		{  0,   0, 255},	/**  8 text 1      **/
		{130, 130, 130},	/**  9 text 2      **/
		{255,   0,   0},	/** 10 text 3      **/
		{135, 135, 135},	/** 11 aux 1       **/
		{120, 120, 120},	/** 12 aux 2       **/
		{255, 255,   0},	/** 13 aux 3       **/
		{200, 100, 100}};	/** 14 aux 4       **/

char Spectrum[][MAX_STRING_LENGTH] = {
		"background",
		"shadow",
		"highlight",
		"surface",
		"surface_inv",
		"dark",
		"dark_inv",
		"select",
		"text_1",
		"text_2",
		"text_3",
		"aux_1",
		"aux_2",
		"aux_3",
		"aux_4"};

unsigned char ColorUsable[][3] = {
		{  0,   0,   0},
		{ 55,  55,  55},
		{ 80,  80,  80},
		{105, 105, 105},
		{130, 130, 130},
		{155, 155, 155},
		{175, 175, 175},
		{195, 195, 195},
		{215, 215, 215},
		{235, 235, 235},
		{255, 255, 255},
		{ 55,   0,   0},
		{ 80,   0,   0},
		{105,   0,   0},
		{130,   0,   0},
		{155,   0,   0},
		{175,   0,   0},
		{195,   0,   0},
		{215,   0,   0},
		{235,   0,   0},
		{255,   0,   0},
		{  0,  55,   0},
		{  0,  80,   0},
		{  0, 105,   0},
		{  0, 130,   0},
		{  0, 155,   0},
		{  0, 175,   0},
		{  0, 195,   0},
		{  0, 215,   0},
		{  0, 235,   0},
		{  0, 255,   0},
		{  0,   0,  55},
		{  0,   0,  80},
		{  0,   0, 105},
		{  0,   0, 130},
		{  0,   0, 155},
		{  0,   0, 175},
		{  0,   0, 195},
		{  0,   0, 215},
		{  0,   0, 235},
		{  0,   0, 255},
		{255, 255, 255},
		{255,   0,   0},
		{  0, 255,   0},
		{  0,   0, 255},
		{255, 255,   0},
		{255,   0, 255},
		{  0, 255, 255},
		{255, 128, 128},
		{128, 255, 128},
		{128, 128, 255},
		{255, 255, 128},
		{255, 128, 255},
		{128, 255, 255}};

unsigned char ColorOrable[][3] = {
		{170, 170, 170},
		{  0,   0,   0},
		{255,   0,   0},
		{  0,   0, 255},
		{  0,   0, 255},
		{255,   0,   0},
		{255, 200, 100},
		{130, 130, 130}};

char Typeset[][MAX_STRING_LENGTH] = {
		"font_0",
		"font_1",
		"font_2",
		"font_3",
		"font_4"};

struct console_info *Console;

struct master_info *Master;
