#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>

/** Mandatory include files **/

#include "pip_constant.h"
#include "pip_extern.h"


/******************************************************************************
  dialog_run (panel_index)
******************************************************************************/

dialog_run (panel_index)
  int panel_index;
{
  Panel *panel;

  panel = Console->panels[panel_index];

  if (!strcmp (panel->name, "file_panel"))
  {
    file_run ();
    return (TRUE);
  }
  else if (!strcmp (panel->name, "message_panel"))
  {
    message_run ();
    return (TRUE);
  }
  else if (!strcmp (panel->name, "browse_panel"))
  {
    browse_run ();
    return (TRUE);
  }

  return (FALSE);
}



/******************************************************************************
  dialog_init (panel_index)
******************************************************************************/

dialog_init (panel_index)
  int panel_index;
{
  Panel *panel;

  panel = Console->panels[panel_index];

  if (!strcmp (panel->name, "file_panel"))
  {
    file_init ();
    return (TRUE);
  }
  else if (!strcmp (panel->name, "message_panel"))
  {
    message_init ();
    return (TRUE);
  }
  else if (!strcmp (panel->name, "browse_panel"))
  {
    browse_init ();
    return (TRUE);
  }

  return (FALSE);
}



/******************************************************************************
  dialog_exit (panel_index)
******************************************************************************/

dialog_exit (panel_index)
  int panel_index;
{
  Panel *panel;

  panel = Console->panels[panel_index];

  if (!strcmp (panel->name, "file_panel"))
  {
    file_exit ();
    return (TRUE);
  }
  else if (!strcmp (panel->name, "message_panel"))
  {
    message_exit ();
    return (TRUE);
  }
  else if (!strcmp (panel->name, "browse_panel"))
  {
    browse_exit ();
    return (TRUE);
  }

  return (FALSE);
}
